import java.beans.Expression;
import java.util.ArrayList;

public abstract class Ast {

    public void visit(){

    }

   
}

class AstExpression extends Ast {

    AstExpression astExpression;
    AstBinaryOp astBinaryOp;
    AstValue astValue;
    
}

class AstBinaryOp extends Ast {

    Ast[] binaryOp = new Ast[3];

}

class AstValue extends Ast {

    AstNumber astNumber;
    AstValue astValue;
    boolean isVariable;

}

class AstNumber extends Ast {

    AstDigitWoz astDigitWoz;
    ArrayList<AstDigit> astDigits = new ArrayList<>();

}

class AstDigitWoz extends Ast {

    int astDigitWozContent;

}

class AstDigit extends Ast {

    int astDigit;

}

class AstDecimal extends Ast {

    AstDigit astDigitBeforeComma;
    AstDigit astDigitAfterComma;


}

class AstOperator extends Ast {

    String astOperator;
}
